<?php
/*  Feed2JS : RSS feed to JavaScript src file

	VERSION 1.93 (2007 nov 13)
	
	ABOUT
	This PHP script will take an RSS feed as a value of src="...."
	and return a JavaScript file that can be linked 
	remotely from any other web page. Output includes
	site title, link, and description as well as item site, link, and
	description with these outouts contolled by extra parameters.
	
	Developed by Alan Levine initially released 13.may.2004
	http://cogdogblog.com/
	
	PRIMARY SITE:
	http://feed2js.org/
	 
	USAGE:
	See http://eduforge.org/projects/feed2js/
     
	Feed2JS makes use of the Magpie RSS parser from
	 http://magpierss.sourceforge.net/
	
   ------------- small print ---------------------------------------
	GNU General Public License 
	Copyright (C) 2004-2005 Alan Levine
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details
	http://www.gnu.org/licenses/gpl.html
	------------- small print ---------------------------------------

*/

// Parse arguments from the command line if we're called that way

if ($argv)
   for ($i=1;$i<count($argv);$i++)
   {
       $it = explode("=",$argv[$i]);
       $_GET[$it[0]] = $it[1];
   }

// ERROR CHECKING FOR NO SOURCE -------------------------------

$data = (isset($_GET['data'])) ? $_GET['data'] : '';
if ($data) $data = file_get_contents($data, FILE_TEXT);

// trap for missing src param for the feed, use a dummy one so it gets displayed.
if (!$data or strlen($data)==0) $data = "NO DATA";

if (strpos($data, '<script')) {
	$data = preg_replace("/(\<script)(.*?)(script>)/i", "SCRIPT DELETED", $data);
}


// MAGPIE  SETUP ----------------------------------------------------
// access configuration settings
define('MAGPIE_DIR', $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . '/magpie/');
require_once(MAGPIE_DIR.'rss_fetch.inc');
require_once(MAGPIE_DIR.'rss_utils.inc');

// value of 2 optionally show lots of debugging info but breaks JavaScript
// This should be set to 0 unless debugging
define('MAGPIE_DEBUG', 0);

// Define cache age in seconds.
define('MAGPIE_CACHE_AGE', 60*60);

// OTHER SETTIINGS ----------------------------------------------
// Output spec for item date string if used
// see http://www.php.net/manual/en/function.date.php
date_default_timezone_set("UTC");
$date_format = "F d, Y h:i:s a";

// server time zone offset from GMT
// If this line generates errors (common on Windoze servers,
//   then figure out your time zone offset from GMT and enter
//   manually, e.g. $tz_offset = -7;
$tz_offset = gmmktime(0,0,0,1,1,1970) - mktime(0,0,0,1,1,1970);

$stylesheet_content = file_get_contents(getcwd() . "/style/historyhound.css");

init();

//  check for utf encoding type
$utf = (isset($_GET['utf'])) ? $_GET['utf'] : 'y';

if ($utf == 'y') {
	define('MAGPIE_CACHE_DIR', MAGPIE_DIR . 'cache_utf8/');
	// character encoding
	define('MAGPIE_OUTPUT_ENCODING', 'UTF-8');

} else {
	define('MAGPIE_CACHE_DIR', MAGPIE_DIR . 'cache/');
}

// GET VARIABLES ---------------------------------------------
// retrieve values from posted variables

// flag to show channel info
$chan = (isset($_GET['chan'])) ? $_GET['chan'] : 'y';

// variable to limit number of displayed items; default = 0 (show all, 100 is a safe bet to list a big list of feeds)

$num = (isset($_GET['num'])) ? $_GET['num'] : 0;
if ($num==0) $num = 100;

// indicator to show item description,  0 = no; 1=all; n>1 = characters to display
// values of -1 indicate to displa item without the title as a link
// (default=0)
$desc = (isset($_GET['desc'])) ? $_GET['desc'] : 1;

// flag to show date of posts, values: no/yes (default=no)
$date = (isset($_GET['date'])) ? $_GET['date'] : 'y';

// time zone offset for making local time, 
// e.g. +7, =-10.5; 'feed' = print the time string in the RSS w/o conversion
$tz = (isset($_GET['tz'])) ? $_GET['tz'] : 'feed';


// flag to open target window in new window; n = same window, y = new window,
// other = targeted window, 'popup' = call JavaScript function popupfeed() to display
// in new window (default is n)

$targ = (isset($_GET['targ'])) ? $_GET['targ'] : 'n';
if ($targ == 'n') {
	// $target_window = ' target="_self"';
	$target_window = '';
} elseif ($targ == 'y' ) {
	$target_window = ' target="_blank"';
} elseif ($targ == 'popup') {
	$target_window = ' onClick="popupfeed(this.href);return false"';
} else {
	$target_window = ' target="' . $targ . '"';
}

// flag to show feed as full html output rather than JavaScript, used for alternative
// views for JavaScript-less users. 
//     y = display html only for non js browsers (NO LONGER USED)
//     n = default (JavaScript view)
//     a = display javascript output but allow HTML 
//     p  = display text only items but convert linefeeds to BR tags

// default setting for no conversion of linebreaks
$html = (isset($_GET['html'])) ? $_GET['html'] : 'n';

$br = ' ';
if ($html == 'a') {
	$desc = 1;
} elseif ($html == 'p') {
	$br = '<br />';
}

// optional parameter to use different class for the CSS container
$rss_box_id = (isset($_GET['css'])) ? '-' . $_GET['css'] : '';

// optional parameter to use different class for the CSS container
$play_podcast = (isset($_GET['pc'])) ? $_GET['pc'] : 'n';


// PARSE FEED and GENERATE OUTPUT -------------------------------
// This is where it all happens!
$rss = new MagpieRSS( $data, MAGPIE_OUTPUT_ENCODING, MAGPIE_INPUT_ENCODING, MAGPIE_DETECT_ENCODING );

// begin javascript output string for channel info
$str= "document.write('<div class=\"rss-box" . $rss_box_id . "\">');\n";


// no feed found by magpie, return error statement
if  (!$rss) {
	$str.= "document.write('<p class=\"rss-item\">$script_msg<em>Error:</em> Feed failed! Causes may be (1) No data  found for RSS feed $src; (2) There are no items are available for this feed; (3) The RSS feed does not validate.<br /><br /> Please verify that the URL <a href=\"$src\">$src</a> works first in your browser and that the feed passes a <a href=\"http://feedvalidator.org/check.cgi?url=" . urlencode($src) . "\">validator test</a>.</p></div>');\n";


} else {


	// Create CONNECTION CONFIRM
	// create output string for local javascript variable to let 
	// browser know that the server has been contacted
	$feedcheck_str = "feed2js_ck = true;\n\n";

	// we have a feed, so let's process
	if ($chan == 'y') {
	
		// output channel title and description	
		$str.= "document.write('<p class=\"rss-title\"><a class=\"rss-title\" href=\"" . trim($rss->channel['link']) . '"' . $target_window . ">" . addslashes(strip_returns($rss->channel['title'])) . "</a><br /><span class=\"rss-description\">" . addslashes(strip_returns(strip_tags($rss->channel['description']))) . "</span></p>');\n";
	
	} elseif ($chan == 'title') {
		// output title only
		$str.= "document.write('<p class=\"rss-title\"><a class=\"rss-title\" href=\"" . trim($rss->channel['link']) . '"' . $target_window . ">" . addslashes(strip_returns($rss->channel['title'])) . "</a></p>');\n";
	
	}	
	
	// begin item listing
	$str.= "document.write('<ul class=\"rss-items\">');\n";
		
	// Walk the items and process each one
	$all_items = array_slice($rss->items, 0, $num);
	
	foreach ( $all_items as $item ) {
		
		// set defaults thanks RPFK
		if (!isset($item['summary'])) $item['summary'] = ''; 
		$more_link = '';
		
		if ($item['link']) {
			// link url
			$my_url = addslashes($item['link']);
		} elseif  ($item['guid']) {
			//  feeds lacking item -> link
			$my_url = ($item['guid']);
		}
		
		
		if ($desc < 0) {
			$str.= "document.write('<li class=\"rss-item\">');\n";
			
		} elseif ($item['title']) {
			// format item title
			$my_title = addslashes(strip_returns($item['title']));
						
			// create a title attribute. thanks Seb!
			$title_str = substr(addslashes(strip_returns(strip_tags((htmlspecialchars($item['summary']))))), 0, 255) . '...'; 

			// write the title strng
			$str.= "document.write('<li class=\"rss-item\"><a class=\"rss-item\" href=\"" . trim($my_url) . "\" title=\"$title_str\"". $target_window . '>' . $my_title . "</a><br />');\n";

		} else {
			// if no title, build a link to tag on the description
			$str.= "document.write('<li class=\"rss-item\">');\n";
			$more_link = " <a class=\"rss-item\" href=\"" . trim($my_url) . '"' . $target_window . ">&laquo;details&raquo;</a>";
		}
	
		// print out date if option indicated

		if ($date == 'y') {
					
			if ($tz == 'feed') {
			//   echo the date/time stamp reported in the feed

				if ($item['pubdate'] != '') {
					// RSS 2.0 is alreayd formatted, so just use it
					$pretty_date = $item['pubdate'];
				} elseif ($item['published'] != "") {
					// ATOM 1.0 format, remove the "T" and "Z" and the time zone offset
					$pretty_date = str_replace("T", " ", $item['published']);
					$pretty_date= str_replace("Z", " ", $pretty_date);
	
				} elseif ($item['issued'] != "") {
					// ATOM 0.3 format, remove the "T" and "Z" and the time zone offset
					$pretty_date = str_replace("T", " ", $item['issued']);
					$pretty_date= str_replace("Z", " ", $pretty_date);
				} elseif ( $item['dc']['date'] != "") {
					// RSS 1.0, remove the "T" and the time zone offset
					$pretty_date = str_replace("T", " ", $item['dc']['date']);
					$pretty_date = substr($pretty_date, 0,-6);
				} else {
				
					// no time/date stamp, 
					$pretty_date =  'n/a';
				}

			} else {
				// convert to local time via conversion to GMT + offset
				
				// adjust local server time to GMT and then adjust time according to user
				// entered offset.
				
				$pretty_date = date($date_format, $item['date_timestamp'] - $tz_offset + $tz * 3600);
			
			}
	
			$str.= "document.write('<span class=\"rss-date\">$pretty_date</span><br />');\n"; 
		}

		// link to podcast media if availavle
		
		if ($play_podcast == 'y' and is_array($item['enclosure'])) {
			$str.= "document.write('<div class=\"pod-play-box\">');\n";
			for ($i = 0; $i < count($item['enclosure']); $i++) {
			
				// display only if enclosure is a valid URL
				//if (strpos($item['enclosure'][$i]['url'], 'http://')!=0) {
					$str.= "document.write('<a class=\"pod-play\" href=\"" . trim($item['enclosure'][$i]['url']) . "\" title=\"Play Now\" target=\"_blank\"><em>Play</em> <span> " .  substr(trim($item['enclosure'][$i]['url']), -3)  . "</span></a> ');\n";
				//}
			
			}
			
			$str.= "document.write('</div>');\n";
		
		}

	
		// output description of item if desired
		if ($desc) {
		
			if ($item['atom_content']) {
				// Atom content - note that wordpress.com feeds return bad data here "A"
				// so revert to description if this is the case.
				$my_blurb = ($item['atom_content'] == "A") ? $item['description'] :   html_entity_decode ( $item['atom_content'], ENT_NOQUOTES, MAGPIE_OUTPUT_ENCODING);
			
			} else if ($item['content']) {
				$my_blurb =   html_entity_decode ( $item['content'], ENT_NOQUOTES, MAGPIE_OUTPUT_ENCODING);
			} else {   
				$my_blurb = $item['summary'];
			}
			
			// strip html
			if ($html != 'a') $my_blurb = strip_tags($my_blurb);
			
			// trim descriptions
			if ($desc > 1) {
			
				// display specified substring numbers of chars;
				//   html is stripped to prevent cut off tags
				$my_blurb = substr($my_blurb, 0, $desc) . '...';
			}
	
			if (strpos($my_blurb, '<script')) {
				$my_blurb = preg_replace("/(\<script)(.*?)(script>)/is", "", $my_blurb);
			}
		
			$str.= "document.write('" . addslashes(strip_returns($my_blurb, $br)) . "');\n"; 
			
		}
			
		$str.= "document.write('$more_link</li>');\n";	
	}


	$str .= "document.write('</ul></div>');\n";
}

// Render as JavaScript
// START OUTPUT
if ($html != 'y') {
	// Render as JavaScript
	// START OUTPUT
	// headers to tell browser this is a JS file
	if ($rss) {
		header("Content-type: application/x-javascript");
	}

	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r";
	echo "<html lang=\"en\">\r<head>\r";
	if ($utf== 'y') {
		echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\r";
	} else {
		echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=iso-8859-1\">\r";
	}
	echo "<title>$title</title>\r";
    echo "<style>$stylesheet_content</style>\r";
	echo "</head>\r<body>\r<div id=\"main\">\r";
	echo "<script language=\"JavaScript\">\r";

	// Spit out the results as the series of JS statements
	echo $str;

	echo "</script>\r</div>\r</body>\r</html>";
	
} else {
	// for HTML output, strip out JavaScript, strip escaped quotes
	$str = preg_replace("/document.write\(\'/", "", $str);
	$str = preg_replace("/\'\)\;/", "", $str);
	$str = stripslashes($str);

	// Now write a basic page with the feed as content
	echo "<html><head><title>RSS Feed: " . $rss->channel['title'] . '</title></head><style type="text/css">';
	echo "#content { margin: 10px 20px;}
p { font-family: verdana, arial, sans-serif; font-size: 12px; margin-top:0; margin-bottom:1em;
	}
h1 { font-family: verdana, arial, sans-serif; font-size: 24px; margin-bottom: 2px;	   text-align:center;}
</style>
</head>";

	echo '<body bgcolor="#FFFFFF"><div id="content">';
	echo '<h1>RSS Feed for ' . $rss->channel['title'] . '</h1><p>Note: Content for this RSS feed is provided as a text alternative to inline RSS feeds that may not display on all browsers.</p>';
	echo "$str</div></body></html>";
}


/*=======================================================================*\
// Utility to remove return characters from strings that might
// pollute JavaScript commands. While we are at it, substitute 
// valid single quotes as well and get rid of any escaped quote
// characters
\*=======================================================================*/
function strip_returns ($text, $linefeed=" ") {
	$subquotes = preg_replace("/&apos;/", "'", stripslashes($text));
	return preg_replace("/(\r\n|\n|\r)/", $linefeed, $subquotes);
}


?>
